#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& stream, bool prompt) {
  Input in;
  size_t number_count;
  if (prompt) {
    cerr << "Enter number count: ";
  }
  stream >> number_count;
  in.numbers.resize(number_count);
  for (size_t i = 0; i < number_count; i++) {
    if (prompt) {
      cerr << "Enter number " << i+1 << ": ";
    }
    stream >> in.numbers[i];
  }
  if (prompt) {
    cerr << "Enter bin count: ";
  }
  stream >> in.bin_count;
  return in;
}

int main() {
    curl_global_init(CURL_GLOBAL_ALL);
    Input in = input_data(cin, false);
    vector<size_t> bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
}
